This website uses cookies to distinguish you from other users of our website. The use of cookies helps us to provide you with a specific service, to facilitate website use, to understand our visitors and to advertise to you. By continuing to browse the site you are giving consent to our use of cookies. Learn more in our Privacy Statement.

Security Services

Microsoft Internet Explorer CAttrArray Invalid Indexing Vulnerability



Internet Explorer is Microsoft's web browser for the Windows platform.


Remote exploitation of an array indexing vulnerability in Microsoft Corp.'s Internet Explorer could allow an attacker to execute arbitrary code with the privileges of the current user. The vulnerability occurs when accessing a VARIANT structure inside of a CAttrArray, which is used to hold element properties. The error occurs when attempting to remove a property that does not exist from an HTML element. In this situation, with certain property values, the function responsible for looking up the index of the property to remove returns an index one beyond the final valid index in the property array. The calling code does not validate this index, and uses it when attempting to remove the VARIANT from the array and destroy it. This results in uninitialized heap memory being treated as a VARIANT structure, which can lead to the execution of arbitrary code.


Exploitation of this vulnerability results in the execution of arbitrary code with the privileges of the user viewing the Web page. To exploit this vulnerability, a targeted user must load a malicious Web page that an attacker created. An attacker typically accomplishes this via social engineering or injecting content into compromised, trusted sites. After the user visits the malicious Web page, no further user interaction is needed.

To exploit this vulnerability, it is necessary to control heap data in the uninitialized index of the array. Testing has demonstrated that this is possible and that it can be performed reliably.


Internet Explorer 9 is vulnerable.


Several workarounds involving disabling or restricting site access to ActiveScript can be employed to mitigate this vulnerability, including the following:

  • Set Internet and Local intranet security zone settings to "High" to block ActiveX Controls and Active Scripting in these zones.
  • Configure Internet Explorer to prompt before running Active Scripting or to disable Active Scripting in the Internet and Local intranet security zone; add trusted sites to the Internet Explorer trusted sites zone.
Keep in mind that disabling or restricting scripting can severely impact the usability of the browser.


Microsoft Corp. has released patches which addresses this issue. For more information, consult their advisory at the following URL:


The Common Vulnerabilities and Exposures (CVE) project has assigned the name CVE-2012-1524 to this issue. This is a candidate for inclusion in the CVE list (, which standardizes names for security problems.


05/09/2012 Initial Vendor Notification
05/09/2012 Initial Vendor Reply
07/10/2012 Coordinated Public Disclosure


This vulnerability was reported to iDefense by Omair.

Get paid for vulnerability research

Free tools, research and upcoming events


Copyright © 2012 Verisign, Inc.

Permission is granted for the redistribution of this alert electronically. It may not be edited in any way without the express written consent of iDefense. If you wish to reprint the whole or any part of this alert in any other medium other than electronically, please e-mail customer service for permission.

Disclaimer: The information in the advisory is believed to be accurate at the time of publishing based on currently available information. Use of the information constitutes acceptance for use in an AS IS condition. There are no warranties with regard to this information. Neither the author nor the publisher accepts any liability for any direct, indirect, or consequential loss or damage arising from use of, or reliance on, this information.